﻿<%@ Page Language="C#" AutoEventWireup="true" CodeBehind="TreeGridDefault.aspx.cs" Inherits="TreeGridSample.TreeGridDefault" %>

<%@ Register TagPrefix="ej" Namespace="Syncfusion.JavaScript.Models" Assembly="Syncfusion.EJ" %>
<!DOCTYPE html>

<html xmlns="http://www.w3.org/1999/xhtml">
<head id="Head1" runat="server">
    <title>Treegrid Sample</title>
    <script src="Scripts/Treegrid/jquery-1.10.2.min.js"></script>
    <script src="Scripts/Treegrid/jquery.globalize.min.js"></script>
    <script src="Scripts/Treegrid/jquery.easing.1.3.min.js"></script>
    <script src="Scripts/Treegrid/jsrender.min.js"></script>
    <script src="Scripts/Treegrid/ej.web.all.min.js"></script>
    <link href="Content/Treegrid/ej.widgets.core.min.css" rel="stylesheet" />
    <link href="Content/Treegrid/ej.theme.min.css" rel="stylesheet" />
</head>   

<body>  
    <div style="padding-bottom:10px;">
        <button id="newrow" onclick="bindData()">Refresh Data</button>
    </div>      
     <form id="form1" runat="server" onsubmit="return false" style="overflow: hidden; padding: 0; margin: 0; height: 100%; width: 100%;">
         <asp:ScriptManager ID="ScriptManager" EnableCdn="true" runat="server" EnablePageMethods="True" />        
        <ej:TreeGrid ID="Treegrid" runat="server" AllowColumnResize="true"
            AllowSorting="true" ChildMapping="Children" EnableVirtualization="true" AllowDragAndDrop="true"
            TreeColumnIndex="1" SelectedRowIndex="2" QueryCellInfo="QueryCellInfo" DateFormat="hh:mm:ss tt">
            <Columns>
                <ej:TreeGridColumn HeaderText="Task Id" Field="Id" Width="40" />
                <ej:TreeGridColumn HeaderText="Task Name" Field="Name" />
                <ej:TreeGridColumn HeaderText="StartDateTime" Field="StartDate" />
                <ej:TreeGridColumn HeaderText="EndDateTime" Field="EndDate" />
                <ej:TreeGridColumn HeaderText="Progress" Field="PercentDone" />
            </Columns>
            <DragTooltip ShowTooltip="true" />                  
            <SizeSettings Width="100%" Height="300px" />
        </ej:TreeGrid>

        <script type="text/javascript">   
            function QueryCellInfo(args) {               
                if (args.type == "queryCellInfo") {

                }
            }
            function bindData() {
                PageMethods.ModifiedData(onsucceed, onfailure);
            }
            function onsucceed(result) {
                //Get the Modified data source from server.
                var TreeGridObject = $("#Treegrid").data("ejTreeGrid"),                   
                    modifiedDataSource = jQuery.parseJSON(result);
                TreeGridObject.refresh(modifiedDataSource);
            }
            function onfailure() {

            }
        </script>
    </form>

</body>
</html>

