﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data.SqlClient;
using System.Web.Configuration;
using System.Web.Services;
using System.Web.Script.Services;
using System.Data;
using System.Web.Script.Serialization;

namespace TreeGridSample
{
    public partial class TreeGridDefault : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            var DataSource = this.GetDataSource();
            this.Treegrid.DataSource = DataSource;
            this.Treegrid.DataBind();  
        }
       public List<BusinessObject> GetDataSource()
        {
            List<BusinessObject> list = new List<BusinessObject>();

            list.Add(new BusinessObject()
            {
                Id =1,
                Name = "Parent Task 1",
                StartDate = "02/23/2014",
                EndDate = "02/27/2014",
                PercentDone = "40",
                Children = (new List<BusinessObject>()
                    {
                        new BusinessObject()
                        {
                            Id = 2,
                            Name = "Child Task 1",
                            StartDate = "02/23/2014",
                            EndDate="02/27/2014",
                            PercentDone = "40",
                        },
                        new BusinessObject()
                        {
                            Id = 3,
                            Name = "Child Task 2",
                            StartDate = "02/23/2014",
                            EndDate="02/27/2014",
                            PercentDone = "40"                            
                        },
                        new BusinessObject()
                        {
                            Id = 4,
                            Name = "Child Task 3",
                            StartDate = "02/23/2014",
                            EndDate="02/27/2014",
                            PercentDone = "40"                            
                        }
                    })

            });

            list.Add(new BusinessObject()
            {
                Id = 5,
                Name = "Parent Task 2",
                StartDate = "03/14/2014",
                EndDate = "03/18/2014",
                PercentDone = "40",
                Children = (new List<BusinessObject>()
                    {
                        new BusinessObject()
                        {
                            Id =6,
                            Name = "Child Task 1",
                            StartDate = "03/02/2014",
                            EndDate="03/06/2014",
                            PercentDone = "40",
                        },
                        new BusinessObject()
                        {
                            Id =7,
                            Name = "Child Task 2",
                            StartDate = "03/02/2014",
                            EndDate="03/06/2014",
                            PercentDone = "40",
                        },
                        new BusinessObject()
                        {
                            Id =8,
                            Name = "Child Task 3",
                            StartDate = "03/02/2014",
                            EndDate="03/06/2014",
                            PercentDone = "40",
                        },
                        new BusinessObject()
                        {
                            Id = 9,
                            Name = "Child Task 4",
                            StartDate = "03/02/2014",
                            EndDate="03/06/2014",
                            PercentDone = "40",
                        }
                    })

            });
            list.Add(new BusinessObject()
            {
                Id = 10,
                Name = "Parent Task 3",
                StartDate = "03/09/2014",
                EndDate = "03/13/2014",
                PercentDone = "40",

                Children = (new List<BusinessObject>()
                    {
                        new BusinessObject()
                        {
                            Id = 11,
                            Name = "Child Task 1",
                            StartDate = "03/9/2014",
                            EndDate="03/13/2014",
                            PercentDone = "40"
                        },
                        new BusinessObject()
                        {
                            Id = 12,
                            Name = "Child Task 2",
                            StartDate = "03/9/2014",
                            EndDate="03/13/2014",
                            PercentDone = "40",
                        },
                        new BusinessObject()
                        {
                            Id = 13,
                            Name = "Child Task 3",
                            StartDate = "03/9/2014",
                            EndDate="03/13/2014",
                            PercentDone = "40"
                        },
                        new BusinessObject()
                        {
                            Id = 14,
                            Name = "Child Task 4",
                            StartDate = "03/9/2014",
                            EndDate="03/13/2014",
                            PercentDone = "40"
                        },
                        new BusinessObject()
                        {
                            Id =15,
                            Name = "Child Task 5",
                            StartDate = "03/9/2014",
                            EndDate="03/13/2014",
                            PercentDone = "40"
                        }
                    })
            });
            return list;
        }

       public List<BusinessObject> RefreshDataSource()
       {
           List<BusinessObject> tasks = new List<BusinessObject>();
           tasks.Add(new BusinessObject()
           {
               Id = 1,
               Name = "Implementation Phase",
               StartDate = "02/17/2014",
               EndDate = "02/27/2014",
               Priority = "Normal",
           });

           tasks[0].Children = new List<BusinessObject>();

           tasks[0].Children.Add(new BusinessObject()
           {
               Id = 2,
               Name = "Phase 1",
               StartDate = "02/17/2014",
               EndDate = "02/27/2014",
               Priority = "High",
           });

           tasks[0].Children[0].Children = new List<BusinessObject>();

           tasks[0].Children[0].Children.Add(new BusinessObject()
           {
               Id = 3,
               Name = "Implementation Module 1",
               StartDate = "02/17/2014",
               EndDate = "02/27/2014",
               Priority = "Normal",
           });

           tasks[0].Children[0].Children[0].Children = new List<BusinessObject>();


           tasks[0].Children[0].Children[0].Children.Add(new BusinessObject()
           {
               Id = 4,
               Name = "Development Task 1",
               StartDate = "02/17/2014",
               EndDate = "02/19/2014",
               Duration = 3,
               PercentDone = "50",
               Priority = "Critical",
               Approved = true,
           });
           tasks[0].Children[0].Children[0].Children.Add(new BusinessObject()
           {
               Id = 5,
               Name = "Development Task 2",
               StartDate = "02/17/2014",
               EndDate = "02/19/2014",
               Duration = 3,
               PercentDone = "50",
               Priority = "Low",
               Approved = true,
           });
           tasks[0].Children[0].Children[0].Children.Add(new BusinessObject()
           {
               Id = 6,
               Name = "Testing",
               StartDate = "02/20/2014",
               EndDate = "02/21/2014",
               Duration = 2,
               PercentDone = "0",
               Priority = "Normal",
               Approved = false,
           });
           tasks[0].Children[0].Children[0].Children.Add(new BusinessObject()
           {
               Id = 7,
               Name = "Bug fix",
               StartDate = "02/24/2014",
               EndDate = "02/25/2014",
               Duration = 2,
               PercentDone = "0",
               Priority = "Low",
               Approved = false,
           });
           tasks[0].Children[0].Children[0].Children.Add(new BusinessObject()
           {
               Id = 8,
               Name = "Customer review meeting",
               StartDate = "02/26/2014",
               EndDate = "02/27/2014",
               Duration = 2,
               PercentDone = "0",
               Priority = "High",
               Approved = true,
           });
           tasks[0].Children[0].Children[0].Children.Add(new BusinessObject()
           {
               Id = 9,
               Name = "Phase 1 complete",
               StartDate = "02/27/2014",
               EndDate = "02/27/2014",
               Duration = 0,
               Priority = "Low",
               Approved = false,
           });

           tasks[0].Children.Add(new BusinessObject()
           {
               Id = 10,
               Name = "Phase 2",
               StartDate = "02/17/2014",
               EndDate = "02/28/2014",
               Priority = "High",
           });

           tasks[0].Children[1].Children = new List<BusinessObject>();

           tasks[0].Children[1].Children.Add(new BusinessObject()
           {
               Id = 11,
               Name = "Implementation Module 2",
               StartDate = "02/17/2014",
               EndDate = "02/28/2014",
               Priority = "Normal",
           });

           tasks[0].Children[1].Children[0].Children = new List<BusinessObject>();

           tasks[0].Children[1].Children[0].Children.Add(new BusinessObject()
           {
               Id = 12,
               Name = "Development Task 1",
               StartDate = "02/17/2014",
               EndDate = "02/20/2014",
               Duration = 4,
               PercentDone = "50",
               Priority = "High",
               Approved = false,
           });
           tasks[0].Children[1].Children[0].Children.Add(new BusinessObject()
           {
               Id = 13,
               Name = "Development Task 2",
               StartDate = "02/17/2014",
               EndDate = "02/20/2014",
               Duration = 4,
               PercentDone = "50",
               Priority = "Critical",
               Approved = true,
           });
           tasks[0].Children[1].Children[0].Children.Add(new BusinessObject()
           {
               Id = 14,
               Name = "Testing",
               StartDate = "02/21/2014",
               EndDate = "02/24/2014",
               Duration = 2,
               PercentDone = "0",
               Priority = "Normal",
               Approved = true,
           });
           tasks[0].Children[1].Children[0].Children.Add(new BusinessObject()
           {
               Id = 15,
               Name = "Bug fix",
               StartDate = "02/25/2014",
               EndDate = "02/26/2014",
               Duration = 2,
               PercentDone = "0",
               Priority = "Critical",
               Approved = false,
           });
           tasks[0].Children[1].Children[0].Children.Add(new BusinessObject()
           {
               Id = 16,
               Name = "Customer review meeting",
               StartDate = "02/27/2014",
               EndDate = "02/28/2014",
               Duration = 2,
               PercentDone = "0",
               Priority = "High",
               Approved = false,
           });
           tasks[0].Children[1].Children[0].Children.Add(new BusinessObject()
           {
               Id = 17,
               Name = "Phase 2 complete",
               StartDate = "02/28/2014",
               EndDate = "02/28/2014",
               Duration = 0,
               Priority = "Low",
               Approved = true,
           });

           tasks[0].Children.Add(new BusinessObject()
           {
               Id = 18,
               Name = "Phase 3",
               StartDate = "02/17/2014",
               EndDate = "02/27/2014",
               Priority = "Critical",
           });
           tasks[0].Children[2].Children = new List<BusinessObject>();

           tasks[0].Children[2].Children.Add(new BusinessObject()
           {
               Id = 19,
               Name = "Implementation Module 3",
               StartDate = "02/17/2014",
               EndDate = "02/27/2014",
               Priority = "High",
           });

           tasks[0].Children[2].Children[0].Children = new List<BusinessObject>();

           tasks[0].Children[2].Children[0].Children.Add(new BusinessObject()
           {
               Id = 20,
               Name = "Development Task 1",
               StartDate = "02/17/2014",
               EndDate = "02/19/2014",
               Duration = 3,
               PercentDone = "50",
               Priority = "High",
               Approved = false,
           });
           tasks[0].Children[2].Children[0].Children.Add(new BusinessObject()
           {
               Id = 21,
               Name = "Development Task 2",
               StartDate = "02/17/2014",
               EndDate = "02/19/2014",
               Duration = 3,
               PercentDone = "50",
               Priority = "Critical",
               Approved = true,
           });
           tasks[0].Children[2].Children[0].Children.Add(new BusinessObject()
           {
               Id = 22,
               Name = "Testing",
               StartDate = "02/20/2014",
               EndDate = "02/21/2014",
               Duration = 2,
               PercentDone = "0",
               Priority = "High",
               Approved = false,
           });
           tasks[0].Children[2].Children[0].Children.Add(new BusinessObject()
           {
               Id = 23,
               Name = "Bug fix",
               StartDate = "02/24/2014",
               EndDate = "02/25/2014",
               Duration = 2,
               PercentDone = "0",
               Priority = "Low",
               Approved = true,
           });
           tasks[0].Children[2].Children[0].Children.Add(new BusinessObject()
           {
               Id = 24,
               Name = "Customer review meeting",
               StartDate = "02/26/2014",
               EndDate = "02/27/2014",
               Duration = 2,
               PercentDone = "0",
               Priority = "Normal",
               Approved = false,
           });
           tasks[0].Children[2].Children[0].Children.Add(new BusinessObject()
           {
               Id = 25,
               Name = "Phase 3 complete",
               StartDate = "02/27/2014",
               EndDate = "02/27/2014",
               Duration = 0,
               Priority = "Critical",
               Approved = true,
           });
           return tasks;
       }
        #region BusinessObject Creation
        public class BusinessObject
        {
            public string StartDate { get; set; }
            public int Id { get; set; }
            public string Name { get; set; }
            public string EndDate { get; set; }
            public string PercentDone { get; set; }
            public int Duration { get; set; }
            public string Priority { get; set; }
            public Boolean Approved { get; set; }
            public List<object> ResourceID { get; set; }
            public List<BusinessObject> Children { get; set; }
            public string Predescessor { get; set; }
        }
        #endregion
       

        [WebMethod]
        public static string ModifiedData()
        {
            TreeGridDefault treegrid = new TreeGridDefault();
            List<BusinessObject> list = treegrid.RefreshDataSource();
            JavaScriptSerializer json = new JavaScriptSerializer();
            return json.Serialize(list);          
        }  
    }
}

